/*
 * config.h
 *
 *  Created on: 2018322
 *      Author: Administrator
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#include <stdint.h>
typedef signed char int8_t;
typedef short int16_t;

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
//typedef unsigned int uint32_t;

#define     __IO    volatile

//#ifndef __CONFIG_H
//#define __CONFIG_H
//
//#include "IO.h"

#define Refresh_Time   50   //ˢʱ䣬λMS(ʱ2)

//汾š
#define VERSIONS        0x0010
#define DEVICE_NAME         "BINARY IR"//60ֽ
#define SOFTWARE_NAME       "BINARY IR control console"//60ֽ

#define DEBUG_MOD 0
//DEBUG-----------------
#define DSP_SYNC
#define DSP_RESET

#define UA10_DUG    1//1Թܣ0رյԹܡ

#define DUG_CPU_SET()           GPIOC->BSRR = GPIO_PIN_9
#define DUG_CPU_RESET()     GPIOC->BSRR = (uint32_t)GPIO_PIN_9 << 16U

#define CPU_TIME_INIT()     HardwareParamter.CPU_Temp = SysTick->VAL

#define CPU_TIME()      HardwareParamter.CPU_User = ((HardwareParamter.CPU_UserFlag==1)?\
                        ((HardwareParamter.CPU_UserFlag=0),((SysTick->LOAD - SysTick->VAL) + HardwareParamter.CPU_Temp)):\
                        (HardwareParamter.CPU_Temp - SysTick->VAL))/HardwareParamter.SystemCoreClock_MHz

//----------------------


//ֵ֧ĲƵʺ궨
#define SAMP_FREQ_44_1KHZ   44100
#define SAMP_FREQ_48_0KHZ   48000
#define SAMP_FREQ_88_2KHZ   88200
#define SAMP_FREQ_96_0KHZ   96000
#define SAMP_FREQ_176_4KHZ  176400
#define SAMP_FREQ_192_0KHZ  192000

#define MAX_SAMP_FREQ   SAMP_FREQ_192_0KHZ//Ƶ

#define AUDIO_BUFF_44_1KHZ      (SAMP_FREQ_44_1KHZ/1000)//44.1KHzƵݻС
#define AUDIO_BUFF_48_0KHZ      (SAMP_FREQ_48_0KHZ/1000)//48KHzƵݻС
#define AUDIO_BUFF_88_2KHZ      (SAMP_FREQ_88_2KHZ/1000)//88.2KHzƵݻС
#define AUDIO_BUFF_96_0KHZ      (SAMP_FREQ_96_0KHZ/1000)//96KHzƵݻС
#define AUDIO_BUFF_176_4KHZ     (SAMP_FREQ_176_4KHZ/1000)//176.4KHzƵݻС
#define AUDIO_BUFF_192_0KHZ     (SAMP_FREQ_192_0KHZ/1000)//192KHzƵݻС
#define MAX_AUDIO_BUFF      (MAX_SAMP_FREQ/1000)//ƵݻС

#define PLAY_CHANNELS   2//ֵ֧ͨ
#define REC_CHANNELS    2//¼ֵ֧ͨ


#define POWER_UP_INIT_STATE                         0//ϵʼ
#define NORMAL_RUN_PRESET                           1//Ԥ
#define EDIT_STATE                                      2//༭״̬
#define BYPASS_STATE                                        3//BYPASS״̬
#define MUTE_STATE                                          4//MUTE״̬
#define SAVE_STATE                                          5//״̬
#define ROOM_SET_STATE                              6//ROOMЧ״̬

#define GLOBAL_STATE                                     7//ȫ״̬
#define FILEWARNING_STATE                        8//ļϵͳ״̬
#define CLEAR_WAIT_STATE                         9//ʽȴ

#define OBJECT_SELECT_STATE              10//״̬ѡ״̬
#define EXP_SUBSTATE_RANGE_STATE             11//Χ״̬
#define TRIAL_SET_STATE                  12//trail״̬
#define CHOSE_INPUT_STATE                    13//ѡ
#define DelayTime_SET_STATE                        14//Delay_Time״̬

#define HID_SYNCH_CMD                                           0x01    //λͬ     豸
#define HID_UN_SYNCH_CMD                                    0x02    //λͬ   豸
#define HID_DECODE_DATA_CMD                             0x03    //̬      豸
#define HID_DECODE_SUCC_CMD                             0x04    //̬ܳɹ    豸  
#define HID_SYNCH_SUCC_CMD                              0x05    //ͬɹ    豸  
#define HID_ERROR_CMD                                           0x06    //  ˫
#define HID_GET_VERSION_CMD                             0x07    //ȡ汾 ˫
#define HID_SEND_VERSION_CMD                            0x08    //Ͱ汾 ˫
#define HID_FIRMWARE_UPDATE_CMD                     0x09    //ϵͳ̼      豸
#define HID_ACK_CMD                                             0x10    //Ӧ  ˫
#define HID_NACK_CMD                                            0x11    //Ӧ ˫
#define HID_DEBUG                                                   0x12    //ԷһЩԲ
#define HID_DEBUG_FACTORY                                   0x13    //ָ    豸
#define HID_DEBUG_IN_PRESET                             0x14    //Ԥ赼    豸
#define HID_DEBUG_OUT_PRESET                            0x15    //Ԥ赼    豸
#define HID_DEBUG_SET_KNOB                              0x16    //ťֵ 豸
#define HID_DEBUG_GET_KNOB                              0x17    //ȡťֵ 豸
#define HID_DEBUG_NORMAL                                    0x18    //豸    豸
#define HID_GET_PRODUCT                                     0x19    //ȡƷ    豸
#define HID_DEBUG_RESTART                                   0x20    //豸    豸
#define HID_DEBUG_SET_PATCH                             0x21    //õǰPATCH/BANK    豸
#define HID_DEBUG_GET_PATCH                             0x22    //ȡǰPATCH/BANK    豸
#define HID_DEBUG_SET_ALOGR                             0x23    //õǰ㷨    豸
#define HID_DEBUG_GET_ALOGR                             0x24    //ȡǰ㷨    豸
#define HID_DEBUG_SET_ALOGRONOFF                    0x25    //Ч/ر   豸
#define HID_DEBUG_GET_ALOGRONOFF                    0x26    //ȡǰЧ״̬  豸
#define HID_DEBUG_SET_CAB                                   0x27    //CAB/ر  豸
#define HID_DEBUG_GET_CAB                                   0x28    //ȡǰCAB״̬ 豸
#define HID_DEBUG_SET_TAPTEMP                           0x29    //TapTemp/ر  豸
#define HID_DEBUG_GET_TAPTEMP                           0x30    //ȡǰTapTemp״̬ 豸
#define HID_DEBUG_SET_OBJECT                            0x31    //ÿƶ    豸
#define HID_DEBUG_GET_OBJECT                            0x32    //ȡƶ    豸
#define HID_DEBUG_SET_TAPTEMP_TIME              0x33    //TAPTEMPʱ   豸
#define HID_DEBUG_GET_TAPTEMP_TIME              0x34    //ȡTAPTEMPʱ   豸
#define HID_DEBUG_SET_DIVIDE                            0x35    //TAPDIVIDEλ 豸
#define HID_DEBUG_GET_DIVIDE                            0x36    //ȡTAPDICIDEλ 豸
#define HID_DEBUG_SET_RANG                              0x37    //ñ̤ƷΧ    豸
#define HID_DEBUG_GET_RANG                              0x38    //ȡ̤ƷΧ    豸
#define HID_DEBUG_MKFS                                      0x39    //ʽSD    豸
#define HID_DEBUG_READ_SD                                   0x40    //ȡSD 豸
#define HID_DEBUG_SET_POWERAMP_NUM              0x41    //úģ  豸
#define HID_DEBUG_GET_POWERAMP_NUM              0x42    //ȡģ  豸
#define HID_DEBUG_SET_AMOUNT                            0x43    //ûAMOUNT  豸
#define HID_DEBUG_GET_AMOUNT                            0x44    //ȡAMOUNT  豸
#define HID_DEBUG_SET_POWERAMP_VAULE            0x45    //POWERAMP  豸
#define HID_DEBUG_GET_POWERAMP_VAULE            0x46    //ȡPOWERAMP  豸
#define HID_DEBUG_SET_MICSTALL                      0x47    //MICλ   豸
#define HID_DEBUG_GET_MICSTALL                      0x48    //ȡMICλ   豸
#define HID_DEBUG_BYPASS                                    0x49    //BYPASS״̬    豸
#define HID_DEBUG_MUTE                                      0x50    //MUTE״̬  豸
#define HID_DEBUG_SET_TRAIL                             0x51    //TRAIL/ر    豸
#define HID_DEBUG_GET_TRAIL                             0x52    //ȡǰTRAIL״̬   豸
#define HID_DEBUG_SAVE                                      0x53    //  豸
#define HID_DEBUG_GET_ALGOR_NAME                    0x54    //ȡ㷨    豸
#define HID_DEBUG_SET_INPUTMOD                      0x55    //ģʽ    豸
#define HID_DEBUG_GET_SET_INPUTMOD              0x56    //ȡģʽ    豸
#define EXTERN_FLASH_WRITE                              0x57    //ⲿFalshд  豸
#define EXTERN_FLASH_READ                                   0x58    //ⲿFalsh  豸
#define ERASURE_EXTERN_FLASH                            0x59    //ⲿFlash 豸
#define WRITE_ERROR                                             0x60    //д  豸  
#define WRITE_SUCCE                                             0x61    //дɹ  豸  
#define DRIVER_FLASH_DATA                                   0x62    //豸flash 豸  
#define ERASURE_ERROR                                           0x63    //  豸  
#define ERASURE_SUCCE                                           0x64    //ɹ  豸  
#define HID_DEBUG_TRANS_STATE               0x65    //豸״̬    豸


#define STATE_IDE     0
#define STATE_BUS     1

#define OFF     1
#define ON      0
#define LED_FLASH   2

#define HID_NOSYNCH     0
#define HID_SYNCH       1

#define OUTMUTE_DELAY  200//лƵʱ3s

#define RUN_WORK_STATE      0//
#define BYPASS_WORK_STATE   1//ֱͨģʽ
#define MUTE_WORK_STATE     2//ģʽ


#define MWX_WAVFILW_NUM         300//wavļ

#define POWER_AMP_ALOGOR_NUM    10//POWER AMP㷨8008
#define MIC_ALOGOR_NUM          10//MIC㷨͸8008
#define ROOM_ALOGOR_NUM         1//ROOM㷨͸8008
#define ALOGOR_NUM              1//MCU㷨һIR

#define ALOGOR_PARA_NUM     10//ܹ11Ҫ͵ڵԤ
    #define VOL_PARA                    0//λ1
    #define MIC_X_PARA                  1//λ2
    #define MIC_Y_PARA                  2//λ3
    #define MIC_Z_PARA                  3//λ4
    #define MIC_TYPE_PARA               4//λ5,ʾ˷
    #define IR_NUM_PARA                 5//IRļ
    #define POWER_AMP_PARA              6//PowerAmp(Ǻģ)
    #define ROOM_OFFON_PARA             7//ROOM쿪
    #define ROOM_AMOUNT_PARA            8//ROOM AMOUNT
    #define POWER_AMP_PRESENCE_PARA     9//PowerAmpɵڲ

#define POWER_AMP_ALOGOR    1//ʾPOWER AMP
#define MIC_ALOGOR          2//ʾ˷
#define ROOM_ALOGOR         3//ʾROOM

//#define ROOM_PARA_AMOUNT  0//ROOM AMOUNT

#define BANK_NUM    10//BANK
#define PATCH_NUM   10//PATCH
#define MICSTALL  11//˷絵λ
#define POWER_AMP_PARA_NUM  8//ģ

typedef struct {
    uint16_t SystemState;
    //SystemState:bit0,1ʾļϵͳʼʹã0ʾļϵͳʹ
    uint32_t ConsoleVer;//̨汾
    uint8_t USBTransState;//USB־

    __IO uint16_t SerialIOState;//

    uint16_t PreaetParaVal[ALOGOR_PARA_NUM];//Ԥֵ
    uint16_t AlgorPara[ALOGOR_PARA_NUM];//殔ǰʹÅ
        //AlgorPara[0]----λ1
        //AlgorPara[1]----λ2
        //AlgorPara[2]----λ3
        //AlgorPara[3]----λ4
        //AlgorPara[4]----λ5
        //AlgorPara[5]----IRļ
        //AlgorPara[6]----PowerAmp(Ǻģ)
        //AlgorPara[7]----ROOM쿪
        //AlgorPara[8]----ROOM AMOUNT
        //AlgorPara[9]----PowerAmpɵڲ

    uint16_t ALgorProcessFun;//浱ǰִеǵڼ㷨00MCUֻ1IR㷨
    uint16_t oldAlgorithmNum;//¼ϴʹõ㷨ļ

    //ParaEdit.bit0=1ʾ0ť0ı䣬0ʾ0ʹԤֵ
    //ParaEdit.bit1=1ʾ1ť0ı䣬0ʾ0ʹԤֵ
    //ParaEdit.bit2=1ʾ2ť0ı䣬0ʾ0ʹԤֵ
    //ParaEdit.bit3=1ʾ3ť0ı䣬0ʾ0ʹԤֵ
    //ParaEdit.bit4=1ʾ4ť0ı䣬0ʾ0ʹԤֵ
    uint16_t ParaEdit;//ָʾǷť仯
    uint16_t OldKnobVal[5];//10%仯ļ
    uint16_t PresetNum;//ǰʹõԤ,099
    uint16_t oldPresetNum;
    uint16_t SeavePresetNum;//ڲλñ
    uint16_t WavFileNum;//wavļϵʼ

    uint16_t returnDetection;//return⣬1ʾ룬0ʾû
    uint16_t OldFunState;
    uint8_t  GlobalVaule;
    uint8_t  Bypass_Mute_State;//ڷֹ󴥷BYPASS/MUTE-->༭״̬/Ԥ״̬
    __IO uint16_t FunState;//״̬
    uint16_t USBDection;//USBγǱ1ʾUSB룬0ʾUSBγ

    __IO uint32_t TimingProcess;//ʱʱ
    __IO uint32_t TimingVal;//
    __IO uint32_t TimingOLED;//ʱʱ
    __IO uint16_t OLEDFlash;//OLEDʾ 1  ˢ½  0 ˢ½
    __IO uint16_t OLEDFlash_flag;
    __IO uint16_t CLEAR_NUM;//лBANKµ
    __IO int fadeStep;
    __IO uint32_t Global_Flash_Vaule;

    //ϵʱڰγUSBʱ
    uint32_t tot_sect;//ܿռС
    uint32_t fre_sect;//ʣռС

    uint16_t HID_INState;
    uint16_t HID_SynchFlag;//0ûкλͬ1:λͬɹ
    uint16_t HID_INCMDFlag;//HID뻥ź,

    __IO float CPU_User;//ִʱ䣬λ΢
    __IO uint32_t CPU_UserFlag;//ɼм
    __IO float SystemCoreClock_MHz;//ɼм
    __IO uint32_t CPU_Temp;//ɼм

    uint32_t tempCun;
    uint32_t TimeMs;
    uint32_t Temp;

    uint8_t MICVaule;//ǰMICĵλ
    uint8_t PreaetMICVaule;
    uint8_t OldMICVaule;
}HardwareParamter_t;


typedef struct {//Ͷȡṹ
    uint8_t AlgorPara[ALOGOR_PARA_NUM];//
    uint8_t MICVaule;//ǰMICĵλ
        //AlgorPara[0]----λ1
        //AlgorPara[1]----λ2
        //AlgorPara[2]----λ3
        //AlgorPara[3]----λ4
        //AlgorPara[4]----λ5
        //AlgorPara[5]----IRļ
        //AlgorPara[6]----PowerAmp(Ǻģ)
        //AlgorPara[7]----ROOM쿪
        //AlgorPara[8]----ROOM AMOUNT
        //AlgorPara[9]----PowerAmpɵڲ
    uint16_t crc;
}ALOGOR_PARA_SAVE_STRUCT_t;//Flash ļ

typedef struct {//Ͷȡṹ
    uint16_t PresetNum;//ǰʹõԤ,099
        //AlgorPara[0]----λ1
        //AlgorPara[1]----λ2
        //AlgorPara[2]----λ3
        //AlgorPara[3]----λ4
        //AlgorPara[4]----λ5
        //AlgorPara[5]----IRļ
        //AlgorPara[6]----PowerAmp(Ǻģ)
        //AlgorPara[7]----ROOM쿪
        //AlgorPara[8]----ROOM AMOUNT
        //AlgorPara[9]----PowerAmpɵڲ
}NOW_AND_START_SAVE_STRUCT_t;//E2PROM


#define PRESET_PARA_NUM                 10//ܹ10
#define PRESET_PARA_SAVE_START_ADDRE    0x0000

#define GLOBAL_PARA_SAVE_START_ADDRE    (PRESET_PARA_SAVE_START_ADDRE+\
                                        (sizeof(ALOGOR_PARA_SAVE_STRUCT_t)*PRESET_PARA_NUM))

#define ALGOR_RUN_DIREC_SAVE_ADDRE  (PRESET_PARA_SAVE_START_ADDRE+\
                                        (sizeof(ALOGOR_PARA_SAVE_STRUCT_t)*PRESET_PARA_NUM)+\
                                         sizeof(NOW_AND_START_SAVE_STRUCT_t))

typedef  void (*pFunction)(void);

extern HardwareParamter_t HardwareParamter;
extern NOW_AND_START_SAVE_STRUCT_t NOW_AND_START_SAVE_STRUCT;
//extern uint32_t UAPdata __attribute__((at(0x2001FFF8))); //ַָ
extern pFunction JumpToApplication;
extern uint32_t JumpAddress;
uint8_t ProgramFlash_BYTE(uint32_t Address, uint8_t * data, uint32_t size);
#define USBD_UPDATA_APP_DEFAULT_ADD 0x8000000

#define FILE_ERROE      0//ȡʧ
#define FILE_COMPLETE   1//ݶȡ
#define FILE_CONTI  2//ʣwavƵ


//ǿϢ
#define KEY_TYPE            1
#define AD_LEVEL_TYPE       2

//ID
//Function = CAB
#define KEY_ONOFF_FOOTSW_1    1
#define KEY_FUNCT_FOOTSW_2      2
#define KEY_SAVE_EXIT_3       3
#define KEY_GLOBAL_4            4
#define KEY_INC_5               5
#define KEY_DEC_6               6
#define IN_DETECTION_R        7//Return
#define OUT_DETECTION_R       8//Send
#define ALL_FOOTSW            9//Ҳȶ


//ADֵ
#define AD_NUM_1    0
#define AD_NUM_2    1
#define AD_NUM_3    2
#define AD_NUM_4    3
#define AD_NUM_5    4
//#define AD_NUM_6  5

#define         DEVICE_ID1          (0x1FFF7A10)
#define         DEVICE_ID2          (0x1FFF7A14)
#define         DEVICE_ID3          (0x1FFF7A18)

#define MAX_PASSWORD_LEN    60
typedef struct {//ڹ̼µʱд豸
    __IO uint8_t SoftwareID[MAX_PASSWORD_LEN];//̶ID
    __IO uint8_t SoftwarePassword[MAX_PASSWORD_LEN];//ͨŶ̬
    __IO uint32_t FomerPassword;//̼
}Password_t;

#define Password    ((Password_t *)(0x08037200))//Կŵַ

#define FILE_LIST   "/FileList"//¼wavļбļ
#define DIR_LIST    "/DirList"//ʱļ
#define PARA_BIN    "/Para.bin"//Ԥļ

//BINļ
#define BIN_SERCRET_KEY   115

#define AA 0x00
#define BB 0x01
#define CC 0x02

#define chiper_judge    (serc == serc_bak)
extern __IO uint32_t serc;
extern __IO uint32_t serc_bak;

#endif


//#endif /* CONFIG_H_ */

