/*
 * d_SPI.c
 *
 *  Created on: 2018322
 *      Author: Administrator
 */
#include "d_SPI.h"

void init_SPI(void)
{
    // Route SPI signals to AD1939 Control Port.
    SRU(SPI_MOSI_O, DPI_PB01_I);     //Connect MOSI to DPI PB1.
    SRU(DPI_PB02_O, SPI_MISO_I);     //Connect DPI PB2 to MISO.
    SRU(SPI_CLK_O, DPI_PB03_I);      //Connect SPI CLK to DPI PB3.
    SRU(SPI_FLG0_O, DPI_PB04_I);     //Connect SPI FLAG0 to DPI PB4.

    // Tie pin buffer enable from SPI peripheral to determine whether they are
    // inputs or outputs
    SRU(SPI_MOSI_PBEN_O, DPI_PBEN01_I);
    SRU(SPI_MISO_PBEN_O, DPI_PBEN02_I);
    SRU(SPI_CLK_PBEN_O, DPI_PBEN03_I);
    SRU(SPI_FLG0_PBEN_O, DPI_PBEN04_I);

    /* setup SPI registers */
    *pSPIDMAC = 0;  //DMAüĴ
    *pSPIBAUD = 0;
    *pSPIFLG = 0xF80;
    *pSPICTL = 0x400;
}
