/*
 * d_analog_I2C.h
 *
 *  Created on: 2018322
 *      Author: Administrator
 */

#ifndef D_ANALOG_I2C_H_
#define D_ANALOG_I2C_H_

#include <sys/platform.h>
#include <sru.h>
#include "config.h"

#define I2C_WR  0       /* дbit */
#define I2C_RD  1       /* bit */

#define CS4272_ADDR      (0x20)//豸I2Cַ(0x0A0)//

void i2c_Start(void);
void i2c_Stop(void);
void i2c_SendByte(uint8_t _ucByte);
uint8_t i2c_ReadByte(void);
uint8_t i2c_WaitAck(void);
void i2c_Ack(void);
void i2c_NAck(void);

void init_analog_I2C(void);
uint8_t CS4272_WriteReg(uint8_t _ucRegAddr, uint8_t _usValue);
uint8_t CS4272_ReadReg(uint8_t ReadAddr);
uint8_t i2c_CheckDevice(uint8_t _Address);

#endif /* D_ANALOG_I2C_H_ */
