/*
 * d_cs4272.c
 *
 *  Created on: 2018322
 *      Author: Administrator
 */

#include "d_cs4272.h"

#define CS4272_RST_HIGH SRU(LOW, DPI_PBEN13_I);
#define CS4272_RST_LOW  SRU(HIGH, DPI_PBEN13_I);


const unsigned char CS4272Config_44KHz1_48KHz[8][2]={
        {0x07, 0x03},// ----- Mode Control 2 - Address 07h
                   //11.2896MHzҪע
        {0x01, 0x49},//0x69450KHzʣģʽDAC I2S 24-bitݸʽ ----- Mode Control 1 - Address 01h
        {0x02, 0x8C},//0x8C ----- DAC Control - Address 02h  ʹmute
        {0x03, 0x29},//0x26 ----- DAC Volume & Mixing Control - Address 03h
        {0x04, 0x00},//Aͨ ----- DAC Channel A Volume Control - Address 04h(0/20/40/60/90)
        {0x05, 0x00},//Bͨ ----- DAC Channel B Volume Control - Address 05h
        {0x06, 0x10},//0x10ADC I2S 24λݸʽ ----- ADC Control - Address 06h
        {0x07, 0x02}//0x02 ----- Mode Control 2 - Address 07h
};

const unsigned char CS4272Config_88KHz2_96KHz[8][2]={
        {0x07, 0x03},// ----- Mode Control 2 - Address 07h
        //11.2896MHzҪע
        {0x01, 0xA9},//50100KHz˫ʣģʽDAC I2S 24-bitݸʽ ----- Mode Control 1 - Address 01h
        {0x02, 0x8C},//0x8C ----- DAC Control - Address 02h    ʹmute
        {0x03, 0x26},//0x29 ----- DAC Volume & Mixing Control - Address 03h
        {0x04, 0x00},//Aͨ ----- DAC Channel A Volume Control - Address 04h
        {0x05, 0x00},//Bͨ ----- DAC Channel B Volume Control - Address 05h
        {0x06, 0x10},//0x10ADC I2S 24λݸʽ ----- ADC Control - Address 06h
        {0x07, 0x02}//0x02 ----- Mode Control 2 - Address 07h
};

const unsigned char CS4272Config_176KHz4_192KHz[8][2]={
        {0x07, 0x03},// ----- Mode Control 2 - Address 07h
                 //11.2896MHzҪע
        {0x01, 0xE9},//100200KHzıʣģʽDAC I2S 24-bitݸʽ ----- Mode Control 1 - Address 01h
        {0x02, 0x8C},//0x8C ----- DAC Control - Address 02h    ʹmute
        {0x03, 0x26},//0x29 ----- DAC Volume & Mixing Control - Address 03h
        {0x04, 0x00},//Aͨ ----- DAC Channel A Volume Control - Address 04h
        {0x05, 0x00},//Bͨ ----- DAC Channel B Volume Control - Address 05h
        {0x06, 0x10},//0x10ADC I2S 24λݸʽ ----- ADC Control - Address 06h
        {0x07, 0x02}//0x02 ----- Mode Control 2 - Address 07h
};

void init_cs4272(void)
{
    //ʼRES
    SRU(FLAG13_O, DPI_PB13_I);

    //RESţֱMCLKȶ
    CS4272_RST_LOW
    delay_ms(50);

    //RESţʼüĴ
    CS4272_RST_HIGH

    //д0x030x07Ĵ
    CS4272_WriteReg(0x07, 0x03);
    CS4272_WriteReg(0x01, 0x49);
    CS4272_WriteReg(0x02, 0x8C);
    CS4272_WriteReg(0x03, 0x29);
    CS4272_WriteReg(0x04, 0x00);
    CS4272_WriteReg(0x05, 0x00);
    CS4272_WriteReg(0x06, 0x10);
    CS4272_WriteReg(0x07, 0x02);
}
