/*****************************************************************************
 * ADSP21489_test.c
 *****************************************************************************/

#include "ADSP21489_test.h"

#include <sys/platform.h>

#include "d_analog_I2C.h"
#include "d_cs4272.h"
#include "d_DAI.h"
#include "d_FFT.h"
#include "d_FIR.h"
#include "d_I2S.h"
#include "d_I2S.h"
#include "d_IIR.h"
#include "d_SPI.h"
#include "init_PLL_SDRAM.h"
#include "time.h"
#include "d_analog_I2C.h"
#include "audio_process.h"

#define CS4272_RST_HIGH SRU(LOW, DPI_PBEN13_I);
#define CS4272_RST_LOW  SRU(HIGH, DPI_PBEN13_I);

int main(void)
{
    /* Initialize SHARC PLL*/
    initPLL();

    /* Initialize DDR2 SDRAM controller to access memory */
    initExternalMemory();

    clearDAIpins();

//    init_analog_I2C();

//    init_cs4272();

//    init_I2S();

//    init_SPI();

    while(1)
    {
        process_CS4272_samples();
    }
}

















